; ==================================================
;  Fellow Amiga Emulator      
;  Copper Emulation
;  (C) 1993-1998 Petter Schau 
;
;  The copper emulation is actually very much older
;  than the rest of the emulator, first implemented
;  in 1993. PS.
; ==================================================


        .586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997

public copperstart_
copperstart_:                   ; Used to check code alignment
startlbl:

include defs.inc
include func\bus.inc
include mac\bus.mac

CPU_LOAD_ADD macro
local nocpuload
        cmp     dword ptr [_cpu_next],-1
        je      nocpuload
        add     dword ptr [_cpu_next],2
nocpuload:
endm


                                ALIGN32

public copper_updatedma_
copper_updatedma_:              test    byte ptr [_copperdma],1
                                jz      copper_updatedma_wasoff

                                ; Here copper was on, test if it is still on.

                                test    byte ptr [_dmacon],080h
                                jnz     copper_updatedma_stillon

                                ; Here copper is being turned off

                                push    edx
                                mov     edx,dword ptr [_nxtcopaccess]
                                mov     dword ptr [_coppersuspendedwait],edx
                                mov     dword ptr [_nxtcopaccess],-1
                                mov     byte ptr [_copperdma],0
                                push    eax
                                push    ebx
                                SCAN_EVENTS_LVL2
                                pop     ebx
                                pop     eax
                                pop     edx
copper_updatedma_stillon:       ret

                                ALIGN32

copper_updatedma_wasoff:        ; Here copper was off, test if it is still off

                                test    byte ptr [_dmacon],080h
                                jz      copper_updatedma_stilloff

                                ; Here copper is being turned on

                                push    edx
                                mov     edx,dword ptr [_coppersuspendedwait]
                                cmp     edx,-1
                                je      copper_updatedma_hanging
                                cmp     edx,dword ptr [_curcycle]
                                ja      copper_updatedma_hanging
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
copper_updatedma_hanging:       mov     dword ptr [_nxtcopaccess],edx
                                push    eax
                                push    ebx
                                SCAN_EVENTS_LVL2
                                pop     ebx
                                pop     eax
                                pop     edx
                                mov     byte ptr [_copperdma],1

copper_updatedma_stilloff:      ret


                                ALIGN32

public copper_restart_
copper_restart_:                mov     edx,dword ptr [_cop1lc]
                                mov     dword ptr [_curcopptr],edx
                                mov     dword ptr [_coppersuspendedwait],40
                                test    byte ptr [_copperdma],1
                                jz      copper_restart_not
                                mov     dword ptr [_nxtcopaccess],40
                                push    eax
                                push    ebx
                                SCAN_EVENTS_LVL2
                                pop     ebx
                                pop     eax
copper_restart_not:             ret

                                ALIGN32

public copper_load1_
copper_load1_:                  mov     edx,dword ptr [_cop1lc]
                                mov     dword ptr [_curcopptr],edx
                                test    byte ptr [_copperdma],1
                                jz      copper_load1_not
                                push    edx
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
                                mov     dword ptr [_nxtcopaccess],edx
                                push    eax
                                push    ebx
                                SCAN_EVENTS_LVL2
                                pop     ebx
                                pop     eax
                                pop     edx
copper_load1_not:               ret


                                ALIGN32

public copper_load2_
copper_load2_:                  mov     edx,dword ptr [_cop2lc]
                                mov     dword ptr [_curcopptr],edx
                                test    byte ptr [_copperdma],1
                                jz      copper_load2_not
                                push    edx
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
                                mov     dword ptr [_nxtcopaccess],edx
                                push    eax
                                push    ebx
                                SCAN_EVENTS_LVL2
                                pop     ebx
                                pop     eax
                                pop     edx
copper_load2_not:               ret


                ALIGN32

; This is assumed to be run from the end of line handler
; Made just to emulate those nice "dents" many demos have in the raster
; bar near the end of the line :-)

public cop_run_until_cycle_6_
cop_run_until_cycle_6_:
                cmp     dword ptr [_nxtcopaccess],-1
                je      cruc6no2
                push    eax
                push    ebx
                push    ecx
                push    edx
                inc     dword ptr [_ypos]
                mov     edx,dword ptr [_xpos]
                push    edx
                mov     edx,dword ptr [_curcycle]
                push    edx
                mov     edx,dword ptr [_ypos]
                mov     edx,dword ptr [_copperytable + 4*edx]
                mov     dword ptr [_curcycle],edx
                mov     dword ptr [_xpos],0
                mov     byte ptr [_cop_running_beyond_line],1
                mov     edx,dword ptr [_nxtcopaccess]   ; Cycles until cop
                sub     edx,dword ptr [_curcycle]
                cmp     edx,6
                jg      cruc6no
cruc6a:         test    edx,edx
                jns     cruc6b
                xor     edx,edx
cruc6b:
                add     dword ptr [_xpos],edx
                add     dword ptr [_curcycle],edx
                push    edx
                call    copemu
                pop     edx
                sub     dword ptr [_curcycle],edx
                sub     dword ptr [_xpos],edx
                cmp     dword ptr [_nxtcopaccess],-1
                je      cruc6no
                mov     edx,dword ptr [_nxtcopaccess]   ; Cycles until cop
                sub     edx,dword ptr [_curcycle]
                cmp     edx,6
                jle     cruc6a
cruc6no:
                dec     dword ptr [_ypos]
                pop     edx
                mov     dword ptr [_curcycle],edx
                pop     edx
                mov     dword ptr [_xpos],edx
                mov     byte ptr [_cop_running_beyond_line],0
                pop     edx
                pop     ecx
                pop     ebx
                pop     eax
cruc6no2:       ret
                

                ALIGN32

public copemu
public copemu_
copemu_:
copemu:
        push    ebx
        push    ecx
        push    edx
        CPU_LOAD_ADD
	mov     ecx,dword ptr _curcopptr
	mov     edx,dword ptr _cmem[ecx]
	bswap   edx
        add     ecx,4
        and     ecx,01ffffeh
        mov     dword ptr _curcopptr,ecx
        cmp     edx,0fffffffeh
        je      notokay
        mov     ecx,edx
	and     edx,0ffffh
	shr     ecx,16
	test    ecx,01h                          ; Zero is MOVE
	jnz     cwait
	and     ecx,000001feh                   ; Move (This works)
        mov     ebx,dword ptr [_bplcon0]
        shr     ebx,12
        and     ebx,0fh
        mov     ebx, dword ptr [_copper_cycletable + 4*ebx]
        add     ebx,dword ptr _curcycle
	mov     dword ptr _nxtcopaccess,ebx
        SCAN_EVENTS_LVL2
        cmp     ecx,80h                         ;
	jae     okay
        test    dword ptr _copcon,0ffffh             ; Access to $40-$7e?
	jz      notokay
	cmp     ecx,40h
	jb      notokay
okay:
        call    dword ptr _iowrite+ecx*2
        pop     edx
        pop     ecx
        pop     ebx
        ret
notokay:mov     dword ptr _nxtcopaccess,-1
        SCAN_EVENTS_LVL2
        pop     edx
        pop     ecx
        pop     ebx
        ret
        

        ALIGN32
cwait:  and     ecx,0fffeh

	test	edx,08000h
	jnz	cnoblit
	test	byte ptr [_blitterstatus],0ffh
	jz	cnoblit
	sub	dword ptr [_curcopptr],4
	mov	ebx,dword ptr [_blitend]
	add	ebx,4
	cmp	ebx,dword ptr [_curcycle]
	ja	cwaitexit
	mov	ebx,dword ptr [_curcycle]
	add	ebx,4
	jmp	cwaitexit
	
cnoblit:
	test    edx,01h                         ; Zero is Wait (Works??)
        jnz     cskip                           ;       (Not really!)

	
	
        ; Calculate our line, masked with vmask
        ; bl - masked ypos 

        mov     ebx,dword ptr _ypos
        or      edx,00008000h                  ; use mask on ypos
        xor     ebp,ebp                         ; Used to indicate
                                                ; correct line or not
        and     bl,dh
        cmp     bl,ch                   ; Compare masked y with wait line.
        ja      cexit                   ; We have passed the line, set up
                                        ; next instruction immediately.
        jb      notnever                ; We are above the line, calculate
                                        ; the cycle when wait is true.

        ; Here we are on the correct line

        ; Calculate our xposition, masked with hmask
        ; al - masked xpos
        

        mov     eax,dword ptr _xpos
        inc     ebp
	and     al,dl                   ; Use mask on xpos
        cmp     al,cl                   ; Compare masked x with wait x
        jae     cexit                   ; Position reached, set up
                                        ; next instruction immediately.

        ; Here the wait position is not reached yet, calculate
        ; cycle when wait is true.
        ; Previous position checks should assure that
        ; a calculated position is not less than the current cycle.

notnever:
        not     edx                     ; Invert masks
        mov     ebx,dword ptr _ypos
        and     bl,dh                   ; Get bits that is not masked out
        or      bl,ch                   ; Mask in bits from waitypos
        mov     ebx,dword ptr _copperytable[ebx*4]
        
        ; When wait is on same line, use masking stuff on xpos,
        ; else on xpos = 0

        and     ecx,0feh                ; Prepare waitxpos
        and     edx,0feh
        xor     eax,eax
        test    ebp,ebp
        jz      copwaitnotsameline
        cmp     edx,dword ptr _xpos
        jae     copwaitnotsameline
        mov     eax,dword ptr _xpos
copwaitnotsameline:
        and     eax,edx                 ; Get unmasked bits from current x
        or      ecx,eax                 ; Mask in horizontal waitpos
        add     ebx,ecx
        add     ebx,4
cwaitexit:	
        mov     dword ptr _nxtcopaccess,ebx
        SCAN_EVENTS_LVL2
        pop     edx
        pop     ecx
        pop     ebx
        ret
        


        ALIGN32

; to help the copper to wait line 256, do some tests here
; Here we have detected a wait position that we are past.
; Check if current line is 255, then if line we are supposed
; to wait for are less than 60, do the wait afterall.

; Here we have detected a wait that has been passed.

cexit:  ;jmp     ctrueexit
        cmp     dword ptr _ypos,255
        jne     ctrueexit               ; Do some tests if line is 255
        cmp     ch,40h                  ; Test line to be waited for
        ja      ctrueexit               ; Line is 256-313, wrong to not wait


; Better to do the wait afterall.
; Here we recalculate the wait stuff,

	not     edx                     ; Invert masks
	mov     ebx,dword ptr _ypos
        or      ebx,0100h
	and     bl,dh                   ; Get missing bits
	or      bl,ch                   ; Mask them into vertical position
        imul    ebx,CYCLESPERLINE
	and     ecx,0feh
	mov     eax,dword ptr _xpos
	and     edx,0feh
	and     eax,edx
	or      ecx,eax                 ; Mask in horizontal
	add     ecx,ebx
	add     ecx,4
	cmp     ecx,dword ptr _curcycle
        ja      cnofix
        mov     ecx,dword ptr _curcycle
        add     ecx,4
cnofix:
fluks:  
	mov     dword ptr _nxtcopaccess,ecx
        SCAN_EVENTS_LVL2
        pop     edx
        pop     ecx
        pop     ebx
        
        ret
        

                ALIGN32
; Here we must do a new copper access immediately (in 4 cycles)
ctrueexit:
        mov     ebx,dword ptr _curcycle
	add     ebx,4
        mov     dword ptr _nxtcopaccess,ebx
        SCAN_EVENTS_LVL2
        pop     edx
        pop     ecx
        pop     ebx
        
        ret
        
; New skip, copied from cwait just to try something

        ALIGN32
cskip: 


        ; Calculate our line, masked with vmask
        ; bl - masked ypos 

        mov     ebx,dword ptr _ypos
        or      edx,00008000h                  ; use mask on ypos
        xor     ebp,ebp                         ; Used to indicate
                                                ; correct line or not
        and     bl,dh
        cmp     bl,ch                   ; Compare masked y with wait line.
        ja      cdoskip                 ; We have passed the line, set up
                                        ; next instruction immediately.
        jb      cdontskip               ; Above line, don't skip

        ; Here we are on the correct line

        ; Calculate our xposition, masked with hmask
        ; al - masked xpos
        

        mov     eax,dword ptr _xpos
        inc     ebp
	and     al,dl                   ; Use mask on xpos
        cmp     al,cl                   ; Compare masked x with wait x
        jb      cdontskip               ; Position reached, set up
                                        ; next instruction immediately.
cdoskip:
        add     dword ptr [_curcopptr],4
cdontskip:
        mov     ebx,dword ptr [_curcycle]
        add     ebx,4
        mov     dword ptr _nxtcopaccess,ebx
        SCAN_EVENTS_LVL2
        pop     edx
        pop     ecx
        pop     ebx
        ret

        ALIGN32

_TEXT ends

_DATA segment para public 'DATA'

include data\copper.inc
include data\memory.inc
include data\bus.inc
include data\blit.inc

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

