; Petter Schau 1996/1997



;================================
; Disable some or all OS drivers
;================================

WITH_OS_KEYBOARD equ 1
WITH_OS_MOUSE equ 1
WITH_OS_JOYSTICK equ 1
WITH_OS_SOUND equ 1
WITH_OS_TIMER equ 1


;======================
; New sprite emulation
;======================

;USE_NEW_SPRITE equ 1


;=====================================================================
; Use graphics emulation in C, replaces USE_C some time in the future 
;=====================================================================

;GRAPHEM_C equ 1

;=======================================================
; Use graphics and drawing routines written in assembly
; C counterpart is USE_C, only one must be defined.
;=======================================================

USE_ASM equ 1

;==============================================
; Enable CPU-history and irq/exception logging
;==============================================

;DEBUGBUILD equ 1

; Don't try these
;TEST_EVENTS_SANITY equ 1
;CPU_TRACE_TO_FILE equ 1
;CPU_LOG_INSTRUCTION_START equ 1

;==========================================
; Use M68k prefetch emulation
; For the moment not compatible with PC_PTR
;==========================================

;PREFETCH equ 1

;=========================
; Direct memory PC-pointer
;=========================

PC_PTR equ 1

;========================================
; Allow odd memory access, (for 68020++) 
;========================================

MEMORY_ALLOW_ODD_ACCESS equ 1

;===============================================
; Support licensed AI software on Amiga Forever
;===============================================

AF_MAP_ROM equ 0e00000h

;========================================================================
; Try to predict what happens when bitplanes are enabled in the middle of
; a line.
;========================================================================

;BPLCON0_KLUDGE equ 1

;============================
; C versus Assembly selection
;============================

;=====================
; Sound emulation in C
;=====================

;SOUND_C equ 1

;======================================
; Use Planar to chunky conversion in C 
;======================================

;PLANAR_C equ 1

;=============================
; Use framebuffer drawing in C 
;=============================

;DRAW_C equ 1



;=====================
; Don't touch the rest
;=====================

;TSC_PROFILING equ 1

CHIPMEM equ 0200000h
FASTMEM equ 0800000h
BOGOMEM equ 01c0000h
KICKMEM equ 0080000h


CYCLESPERLINE equ 228
CYCLESPERFRAME equ 71364
LINESPERFRAME equ 313


TSC_BEFORE macro TMPVARIABLE
#ifdef TSC_PROFILING
                push    eax
                push    edx
                push    ecx
                mov     ecx,10h
                rdtsc
                pop     ecx
                mov     dword ptr [TMPVARIABLE],eax
                mov     dword ptr [TMPVARIABLE+4],edx
                pop     edx
                pop     eax
#endif
endm

TSC_AFTER macro TMPVARIABLE, VARIABLE, TIMES
#ifdef TSC_PROFILING
                push    eax
                push    edx
                push    ecx
                mov     ecx,10h
                rdtsc
                pop     ecx
                sub     eax,dword ptr [TMPVARIABLE]
                sbb     edx,dword ptr [TMPVARIABLE+4]
                add     dword ptr [VARIABLE],eax
                adc     dword ptr [VARIABLE+4],edx
                inc     dword ptr [TIMES]
                pop     edx
                pop     eax
#endif
endm

ALIGN32 macro 
        local loca
        align   16
loca:
        if ((loca - startlbl) and 010h) eq 010h
                nop
                align   16
        endif
endm

